<template>
    <v-row>
        <v-col>
            <plan-form
                mode="edit"
                :clearable="false"
                :loading="loading"
                @status="onStatusChange"
                @remove-charges="onRemoveCharges"
                @remove-policies="onRemovePolicies"
                v-model="plan"
            ></plan-form>
        </v-col>
        <v-dialog
            v-model="showUpdateStatusWarning"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="title primary white--text">
                    {{ $t('status_action.title') }}
                </v-card-title>
                <v-card-text class="subtitle">{{ updateStatusWarning }}</v-card-text>
                <v-card-actions class="justify-center">
                    <v-btn
                        :loading="updating"
                        @click="onCancelUpdateStatus"
                        color="primary darken-1"
                        text
                    >
                        {{ $t('cancel') }}
                    </v-btn>
                    <v-btn
                        :loading="updating"
                        @click="onConfirmUpdateStatus"
                        color="primary darken-1"
                        text
                    >
                        {{ $t('confirm') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
        <v-dialog
            v-model="showRemoveChargesWarning"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('remove_', [$tc('charge', 2)]) }}
                </v-card-title>
                <v-card-text class="subtitle">{{ $t('plan_action.charges.warning') }}</v-card-text>
                <v-card-actions class="justify-center">
                    <v-btn
                        :loading="updating"
                        @click="onCancelRemoveCharges"
                        color="primary darken-1"
                        text
                    >
                        {{ $t('cancel') }}
                    </v-btn>
                    <v-btn
                        :loading="updating"
                        @click="onConfirmRemoveCharges"
                        color="primary darken-1"
                        text
                    >
                        {{ $t('confirm') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="showRemovePoliciesWarning"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('remove_', [$tc('policy', 2)]) }}
                </v-card-title>
                <v-card-text class="subtitle">{{ $t('plan_action.policies.warning') }}</v-card-text>
                <v-card-actions class="justify-center">
                    <v-btn
                        :loading="updating"
                        @click="onCancelRemovePolicies"
                        color="primary darken-1"
                        text
                    >
                        {{ $t('cancel') }}
                    </v-btn>
                    <v-btn
                        :loading="updating"
                        @click="onConfirmRemovePolicies"
                        color="primary darken-1"
                        text
                    >
                        {{ $t('confirm') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import PlanForm from "./PlanForm";
    import { mapMutations } from "vuex";

    export default {
        name: "PlanEdit",
        components: {PlanForm},
        props: ['id'],
        data: () => ({
            plan: {
                id: 0,
                name: '',
                slug: '',
                amount: 0,
                purchase_amount: 0,
                description: '',
                info: '',
                enabled: undefined,
                featured: undefined,
                exchange_limit: 0,
                max_price: 0,
                max_qty: 0,
                policies: [],
                surcharges: [],
                sms:[]
            },
            showUpdateStatusWarning: false,
            showRemoveChargesWarning: false,
            showRemovePoliciesWarning: false,
            loading: false,
            updating: false,
            snackbar: {
                show: false,
                color: null,
                timeout: 6000,
                message: ''
            },
            selectedCharges: null,
            selectedPolicies: null
        }),
        created() {
            this.fetchPlan();
        },
        computed: {
            updateStatusWarning() {
                const status = this.plan.enabled ? this.$t('enabled') : this.$t('disabled');

                return this.$t('status_action.updateStatusWarning', {
                    status: status.toLowerCase(),
                    name: this.$t('plan')
                });
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            onStatusChange() {
                this.showUpdateStatusWarning = true;
            },

            onCancelUpdateStatus() {
                this.showUpdateStatusWarning = false;
                this.plan.enabled = !this.plan.enabled;
            },

            onConfirmUpdateStatus() {
                this.updating = true;

                axios.put(`api/plans/${this.id}/status`,
                    { enabled: this.plan.enabled })
                    .then(() => {
                        this.success(this.$t('plan_action.status.updated'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.updating = false;
                        this.showUpdateStatusWarning = false;
                    })
            },

            onRemoveCharges(id) {
                this.showRemoveChargesWarning = true;
                this.selectedCharges = id;
            },

            onRemovePolicies(id) {
                this.showRemovePoliciesWarning = true;
                this.selectedPolicies = id;

                console.log(id)
            },

            onCancelRemoveCharges() {
                this.showRemoveChargesWarning = false;
                this.selectedCharges = null;
            },

            onCancelRemovePolicies() {
                this.showRemovePoliciesWarning = false;
                this.selectedPolicies = null;
            },

            onConfirmRemoveCharges() {
                this.updating = true;

                axios.delete(`api/plans/${this.id}/surcharges/${this.selectedCharges}`)
                    .then(() => {
                        const index = this.plan.surcharges.findIndex(s => s.id === this.selectedCharges);
                        this.plan.surcharges.splice(index, 1);
                        this.success(this.$t('plan_action.charges.removed'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.updating = false;
                        this.selectedCharges = null;
                        this.showRemoveChargesWarning = false;
                    })
            },

            onConfirmRemovePolicies() {
                this.updating = true;

                axios.delete(`api/plans/${this.id}/policies/${this.selectedPolicies}`)
                    .then(() => {
                        const index = this.plan.policies.findIndex(s => s.id === this.selectedPolicies);
                        this.plan.policies.splice(index, 1);
                        this.success(this.$t('plan_action.policies.removed'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.updating = false;
                        this.selectedPolicies = null;
                        this.showRemovePoliciesWarning = false;
                    })
            },

            fetchPlan() {
                this.loading = true;

                axios.get(`api/plans/${this.id}`)
                    .then(({ data }) => {
                        this.loading = false;
                        this.plan = data;
                        this.plan.enabled = Number(this.plan.enabled);
                    })
            }
        }
    }
</script>

<style >

</style>
